//
// Copyright (c) 2010-2011 StreamBase Systems, Inc. All rights reserved.
//
package com.streambase.sb.contrib.adapter.jmx;

import java.lang.management.GarbageCollectorMXBean;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Schema;
import com.streambase.sb.Tuple;
import com.streambase.sb.TupleException;

public class GarbageCollectorSchemaHelper {	    
    public static final String NAME_NAME="Name";
    public static final String COUNT_NAME="Count";
    public static final String TIME_NAME="TotalMS";
    
    public static final Schema.Field[] FIELDS = {
        new Schema.Field(NAME_NAME, CompleteDataType.forString()),
        new Schema.Field(COUNT_NAME, CompleteDataType.forLong()),
        new Schema.Field(TIME_NAME, CompleteDataType.forLong()),
    };
    
    public static Schema SCHEMA = new Schema(null, FIELDS);
    
    public static final int IDX_FIELD_NAME = SCHEMA.getFieldIndex(NAME_NAME);
    public static final int IDX_FIELD_COUNT = SCHEMA.getFieldIndex(COUNT_NAME);
    public static final int IDX_FIELD_TIME = SCHEMA.getFieldIndex(TIME_NAME);
   
    public static Tuple populateTuple(GarbageCollectorMXBean gbean) throws TupleException {
        return populateTuple(createTuple(), gbean);
    }
    
    public static Tuple populateTuple(Tuple tuple, GarbageCollectorMXBean gbean) throws TupleException {
        tuple.clear();
        
        tuple.setString(IDX_FIELD_NAME, gbean.getName());
        if (!gbean.isValid()) {
        	return tuple;
        }
        tuple.setLong(IDX_FIELD_COUNT, gbean.getCollectionCount());
        tuple.setLong(IDX_FIELD_TIME, gbean.getCollectionTime());
        return tuple;
    }
    
    public static Tuple createTuple() {
        return SCHEMA.createTuple();
    }
}
