//
// Copyright (c) 2010-2011 StreamBase Systems, Inc. All rights reserved.
//
package com.streambase.sb.contrib.adapter.jmx;

import java.lang.management.OperatingSystemMXBean;
import java.lang.management.RuntimeMXBean;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Schema;
import com.streambase.sb.Tuple;
import com.streambase.sb.TupleException;

public class GeneralSchemaHelper {
    public static final String 	UPTIME_NAME="UpTimeMS";
    public static final String LOAD_NAME="SystemLoadAve";
    
    public static final Schema.Field[] FIELDS = {
        new Schema.Field(UPTIME_NAME, CompleteDataType.forLong()),
        new Schema.Field(LOAD_NAME, CompleteDataType.forDouble()),
    };
    
    public static Schema SCHEMA = new Schema(null, FIELDS);
    
    public static final int IDX_FIELD_UPTIME = SCHEMA.getFieldIndex(UPTIME_NAME);
    public static final int IDX_FIELD_LOAD = SCHEMA.getFieldIndex(LOAD_NAME);
  
    public static Tuple populateTuple(Tuple tuple, OperatingSystemMXBean OSBean, RuntimeMXBean RTbean) throws TupleException {
        tuple.clear();
        
        tuple.setLong(IDX_FIELD_UPTIME, RTbean.getUptime());
        tuple.setDouble(IDX_FIELD_LOAD, OSBean.getSystemLoadAverage());
 
        return tuple;
    }
}
