//
// Copyright (c) 2010-2011 StreamBase Systems, Inc. All rights reserved.
//
package com.streambase.sb.contrib.adapter.jmx;

import java.lang.management.MemoryMXBean;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Schema;
import com.streambase.sb.Tuple;
import com.streambase.sb.TupleException;

public class MemorySchemaHelper {
    public static final String 	HEAP_NAME="HeapSize";
    public static final String NON_HEAP_NAME="NonHeapSize";
    
    public static final Schema.Field[] FIELDS = {
        new Schema.Field(HEAP_NAME, CompleteDataType.forLong()),
        new Schema.Field(NON_HEAP_NAME, CompleteDataType.forLong()),
    };
    
    public static Schema SCHEMA = new Schema(null, FIELDS);
    
    public static final int IDX_FIELD_HEAP = SCHEMA.getFieldIndex(HEAP_NAME);
    public static final int IDX_FIELD_NON_HEAP = SCHEMA.getFieldIndex(NON_HEAP_NAME);

    public static Tuple populateTuple(MemoryMXBean membean) throws TupleException {
        return populateTuple(createTuple(), membean);
    }
    
    public static Tuple populateTuple(Tuple tuple, MemoryMXBean membean) throws TupleException {
        tuple.clear();
        
        tuple.setLong(IDX_FIELD_HEAP, membean.getHeapMemoryUsage().getUsed());
        tuple.setLong(IDX_FIELD_NON_HEAP, membean.getNonHeapMemoryUsage().getUsed());
 
        return tuple;
    }
    
    public static Tuple createTuple() {
        return SCHEMA.createTuple();
    }
}
